# dillo-did

[Dillo][] plugin for [did][] ([Decentralized Identifier][did-core]) URIs. Written in [Rust][]. Build using [Cargo][]. Uses [`ssi`][]/[DIDKit][].

## Screenshot

![dillo-did-key.png](dillo-did-key.png)

## Fetch

Get the source from one of the repository mirrors...
### from [git-ssb][]
```
git clone ssb://%T8QyhgamH7fmOiiYV/iWiSRmTDdxXje77teBB2yijGU=.sha256 dillo-did
```
### from Codeberg
```
git clone https://codeberg.org/cel2/dillo-did
```
### from Woodbine
```
git clone https://git.woodbine.nyc/cel/dillo-did
```

## Build & Install
```
cd dillo-did
make install
dpidc stop
```
You can also use `make link` instead of `make install`, to install via a symlink.

## Built-in supported [DID methods][]

- [did:key][]
- [did:web][]
- [did:tz][]

## Fallback resolver for additional DID methods

Set environmental variable `DID_RESOLVER` to a URL for a [DID Resolver HTTP(S) endpoint][did-http] - e.g. to an instance of [Universal Resolver][].

## TODO

- Make external resolver URL(s) configurable via a config file
- Render DID documents more nicely

## Discuss

- Public mailing list of the W3C Decentralized Identifiers Working Group: https://lists.w3.org/Archives/Public/public-did-wg/2021Feb/0005.html (announcement)
- Secure Scuttlebutt: [%S1iakA5zMkyDrdQGImP+oExY3KXnae3bCsfI2Tz/dPY=.sha256](https://viewer.scuttlebot.io/%25S1iakA5zMkyDrdQGImP%2BoExY3KXnae3bCsfI2Tz%2FdPY%3D.sha256)

## License

Apache License, Version 2.0

[Dillo]: https://en.wikipedia.org/wiki/Dillo
[Rust]: https://www.rust-lang.org/
[Cargo]: https://github.com/rust-lang/cargo
[did]: https://www.iana.org/assignments/uri-schemes/prov/did
[did-core]: https://www.w3.org/TR/did-core/
[git-ssb]: https://git.scuttlebot.io/%25n92DiQh7ietE%2BR%2BX%2FI403LQoyf2DtR3WQfCkDKlheQU%3D.sha256
[DIDKit]: https://github.com/spruceid/didkit
[`ssi`]: https://github.com/spruceid/ssi
[did:key]: https://w3c-ccg.github.io/did-method-key/
[did:web]: https://w3c-ccg.github.io/did-method-web/
[did:tz]: https://github.com/spruceid/did-tezos/
[did-http]: https://w3c-ccg.github.io/did-resolution/#bindings-https
[DID methods]: https://w3c.github.io/did-core/#methods
[Universal Resolver]: https://github.com/decentralized-identity/universal-registrar/
